////////////////////////////////////////////////////////////
// Euclides's The easyest hard problem ;)
// Keygen by jB
// Aug. 29th, 2005
//
// MD5, CRT
////////////////////////////////////////////////////////////


#define WIN32_LEAN_AND_MEAN

#include <windows.h> 	
#include "resource.h"
#include "miracl.h"
#include "global.h"
#include "md5.h"

#define MIN_NAME 0
#define MAX_NAME 32

DWORD WINAPI GenererSerial(HWND hwnd);
HINSTANCE hInst;

int primetable[256]={
		0x139, 0x13D, 0x14B, 0x151, 0x15B, 0x15D, 0x161, 0x167, 0x16F,
		0x175, 0x17B, 0x17F, 0x185, 0x18D, 0x191, 0x199, 0x1A3, 0x1A5,
		0x1AF, 0x1B1, 0x1B7, 0x1BB, 0x1C1, 0x1C9, 0x1CD, 0x1CF, 0x1D3,
		0x1DF, 0x1E7, 0x1EB, 0x1F3, 0x1F7, 0x1FD, 0x209, 0x20B, 0x21D,
		0x223, 0x22D, 0x233, 0x239, 0x23B, 0x241, 0x24B, 0x251, 0x257,
		0x259, 0x25F, 0x265, 0x269, 0x26B, 0x277, 0x281, 0x283, 0x287,
		0x28D, 0x293, 0x295, 0x2A1, 0x2A5, 0x2AB, 0x2B3, 0x2BD, 0x2C5,
		0x2CF, 0x2D7, 0x2DD, 0x2E3, 0x2E7, 0x2EF, 0x2F5, 0x2F9, 0x301,
		0x305, 0x313, 0x31D, 0x329, 0x32B, 0x335, 0x337, 0x33B, 0x33D,
		0x347, 0x355, 0x359, 0x35B, 0x35F, 0x36D, 0x371, 0x373, 0x377,
		0x38B, 0x38F, 0x397, 0x3A1, 0x3A9, 0x3AD, 0x3B3, 0x3B9, 0x3C7,
		0x3CB, 0x3D1, 0x3D7, 0x3DF, 0x3E5, 0x139, 0x13D, 0x14B, 0x151,
		0x15B, 0x15D, 0x161, 0x167, 0x16F, 0x175, 0x17B, 0x17F, 0x185,
		0x18D, 0x191, 0x199, 0x1A3, 0x1A5, 0x1AF, 0x1B1, 0x1B7, 0x1BB,
		0x1C1, 0x1C9, 0x1CD, 0x1CF, 0x1D3, 0x1DF, 0x1E7, 0x1EB, 0x1F3,
		0x1F7, 0x1FD, 0x209, 0x20B, 0x21D, 0x223, 0x22D, 0x233, 0x239,
		0x23B, 0x241, 0x24B, 0x251, 0x257, 0x259, 0x25F, 0x265, 0x269,
		0x26B, 0x277, 0x281, 0x283, 0x287, 0x28D, 0x293, 0x295, 0x2A1,
		0x2A5, 0x2AB, 0x2B3, 0x2BD, 0x2C5, 0x2CF, 0x2D7, 0x2DD, 0x2E3,
		0x2E7, 0x2EF, 0x2F5, 0x2F9, 0x301, 0x305, 0x313, 0x31D, 0x329,
		0x32B, 0x335, 0x337, 0x33B, 0x33D, 0x347, 0x355, 0x359, 0x35B,
		0x35F, 0x36D, 0x371, 0x373, 0x377, 0x38B, 0x38F, 0x397, 0x3A1,
		0x3A9, 0x3AD, 0x3B3, 0x3B9, 0x3C7, 0x3CB, 0x3D1, 0x3D7, 0x3DF,
		0x3E5, 0x1A3, 0x1A5, 0x1AF, 0x1B1, 0x1B7, 0x1BB, 0x1C1, 0x1C9,
		0x1CD, 0x1CF, 0x1D3, 0x1DF, 0x1E7, 0x1EB, 0x1F3, 0x1F7, 0x1FD,
		0x209, 0x20B, 0x21D, 0x223, 0x22D, 0x233, 0x239, 0x23B, 0x241,
		0x24B, 0x251, 0x257, 0x259, 0x25F, 0x265, 0x269, 0x26B, 0x277,
		0x281, 0x283, 0x287, 0x28D, 0x293, 0x295, 0x2A1, 0x2A5, 0x2AB,
		0x2B3, 0x2BD, 0x2C5, 0x2CF
}; 

BOOL CALLBACK DlgProc( HWND hwnd, UINT uMsg, WPARAM wParam,LPARAM lParam)
{ 
   switch (uMsg)
   {
   		case WM_CLOSE:
   			EndDialog(hwnd,0); 
   			break;

		case WM_INITDIALOG:
			SetWindowText(hwnd,"KeygenMe #3 by Euclides");
			SetDlgItemText(hwnd,IDC_NAME,"jB");			
			SendDlgItemMessage(hwnd,IDC_NAME,EM_LIMITTEXT,MAX_NAME,0);
			SetFocus(GetDlgItem(hwnd,IDC_NAME));
			return FALSE;
			
 		case WM_COMMAND:
   			switch(LOWORD(wParam))
   			{
   			case IDC_NAME:
				GenererSerial(hwnd);
				break;
			case IDC_EXIT:
				EndDialog(hwnd,0);
				break;
   			}
 		default:
   			return FALSE;
   }
   
   return TRUE;
}


int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{ 
	hInstance = GetModuleHandle(NULL);
	hInst = hInstance;
	DialogBoxParam(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),NULL,DlgProc,(LPARAM)NULL);
 	return 0;
}

DWORD WINAPI GenererSerial(HWND hwnd){
	MD5_CTX context;
	miracl *mip=mirsys(50,0);
	mip->IOBASE=16;

    char name[35];
	char serial[20],serial2[20];
	unsigned char s[20];
	
	int i,len;

	big bigserial;
	big *hash;
	big *primes;
	big_chinese bc;
	
	GetDlgItemText(hwnd,IDC_NAME,name,MAX_NAME);
	len=strlen(name);
	if(len<MIN_NAME || len>MAX_NAME){
		SetDlgItemText(hwnd, IDC_SERIAL,"Please enter a valid name...");
		return 0;
	}

    MD5Init(&context);
    MD5Update(&context, name, len);
    MD5Final(s,&context);	

	hash=malloc(4*sizeof(big));
	primes=malloc(4*sizeof(big));

	bigserial=mirvar(0);
	for(i=0;i<4;i++){
		hash[i]=mirvar(0);
		lgconv(s[i+8],hash[i]);
		primes[i]=mirvar(0);
		lgconv(primetable[s[i]],primes[i]);
	}

    crt_init(&bc,4,primes);
	crt(&bc,hash,bigserial);
	crt_end(&bc);
	cotstr(bigserial,serial2);

	for(i=0;i<16;i++) serial[i]='0';
	strcpy(serial+16-strlen(serial2),serial2);
	SetDlgItemText(hwnd,IDC_SERIAL,serial);

	for(i=0;i<4;i++){
		mirkill(hash[i]);
		mirkill(primes[i]);
	}
	mirkill(bigserial);
	mirexit();

    return 0;
}